//! Rust intrinsics for panic handling.
//!
//! These are usually provided by `std`,
//! but we don't have that luxury!

use core::arch::asm;
use core::panic::PanicInfo;

// Use serial println
use crate::println;

#[lang = "eh_personality"]
#[no_mangle]
pub extern "C" fn rust_eh_personality() {}

#[panic_handler]
#[no_mangle]
pub fn rust_begin_unwind(info: &PanicInfo<'_>) -> ! {
	unsafe {
		println!("TETRIS PANIC:\n{}", info);
		loop {
			asm!("hlt");
		}
	}
}

#[no_mangle]
pub extern "C" fn _Unwind_Resume() -> ! {
	loop {
		unsafe {
			asm!("hlt");
		}
	}
}
